/************************************************************************************/
/*  Program name CAPAPIMP_INV_B.sql                                                 */
/*  Creater:  WONG Wing Kin (PCCW - UniHub)                                         */
/*************   History   *************************                                */
/* 30 NOV, 2005   WONG Wing Kin         First created                               */
/************************************************************************************/
SET SERVEROUTPUT ON SIZE 1000000;

DECLARE
	lv_Prog_ID		VARCHAR2(100)	:=	'CAPAPIMP_INV_B';

	lv_Scc_Count	NUMBER			:=	0;
	lv_Err_Count	NUMBER			:=	0;
	lv_Err_Msg		VARCHAR2(500)	:=	'No Error';

	CURSOR Cur_F IS
	SELECT
		*
	FROM
		CRST_AP_BATCHES;

	lv_Next_Seq_ID	NUMBER;
	lv_SOB_Name		VARCHAR2(20);
	lv_COA_ID		NUMBER;

BEGIN

	FOR C1 IN Cur_F LOOP
		BEGIN
			SELECT	AP_BATCHES_S.NextVal
			--SELECT	AP_BATCHES_ALL_S.NextVal
			INTO	lv_Next_Seq_ID
			FROM	DUAL;

			INSERT INTO CRST_AP_BATCHES_MAP VALUES
			(
			C1.BATCH_ID,
			C1.BATCH_NAME,
			C1.BATCH_DATE,
			C1.ORG_ID,
			lv_Next_Seq_ID,
			C1.BATCH_NAME,
			C1.BATCH_DATE,
			CAPBRIMP_COMMON.GetOrgID(C1.ORG_NAME)
			);
			
			--lv_SOB_Name	:=	CAPBRIMP_COMMON.GetSOBShortName(CAPBRIMP_COMMON.GetOrgID(C1.ORG_NAME));
			lv_SOB_Name	:=	CAPBRIMP_COMMON.GetSOBShortNameOU(CAPBRIMP_COMMON.GetOrgID(C1.ORG_NAME));
			lv_COA_ID	:=	CAPBRIMP_COMMON.GetCOAID(lv_SOB_Name);

			INSERT INTO AP_BATCHES_ALL
			VALUES
			(
			lv_Next_Seq_ID,											--BATCH_ID,
			C1.BATCH_NAME,
			C1.BATCH_DATE,
			C1.LAST_UPDATE_DATE,
			CAPBRIMP_COMMON.GetUser(C1.LAST_UPDATED_BY_NAME),		--LAST_UPDATED_BY,
			C1.CONTROL_INVOICE_COUNT,
			C1.CONTROL_INVOICE_TOTAL,
			C1.ACTUAL_INVOICE_COUNT,
			C1.ACTUAL_INVOICE_TOTAL,
			C1.INVOICE_CURRENCY_CODE,
			C1.PAYMENT_CURRENCY_CODE,
			C1.LAST_UPDATE_LOGIN,
			C1.CREATION_DATE,
			CAPBRIMP_COMMON.GetUser(C1.CREATED_BY_NAME),			--CREATED_BY,
			C1.PAY_GROUP_LOOKUP_CODE,
			CAPBRIMP_COMMON.GetSegment(lv_COA_ID,C1.BATCH_CCID_D),	--BATCH_CODE_COMBINATION_ID,
			CAPBRIMP_COMMON.GetAPTerm(C1.AP_Term),					--TERMS_ID,
			C1.ATTRIBUTE_CATEGORY,
			C1.ATTRIBUTE1,
			C1.ATTRIBUTE2,
			C1.ATTRIBUTE3,
			C1.ATTRIBUTE4,
			C1.ATTRIBUTE5,
			C1.ATTRIBUTE6,
			C1.ATTRIBUTE7,
			C1.ATTRIBUTE8,
			C1.ATTRIBUTE9,
			C1.ATTRIBUTE10,
			C1.ATTRIBUTE11,
			C1.ATTRIBUTE12,
			C1.ATTRIBUTE13,
			C1.ATTRIBUTE14,
			C1.ATTRIBUTE15,
			C1.INVOICE_TYPE_LOOKUP_CODE,
			C1.HOLD_LOOKUP_CODE,
			C1.HOLD_REASON,
			C1.DOC_CATEGORY_CODE,
			CAPBRIMP_COMMON.GetOrgID(C1.ORG_NAME),					--ORG_ID,
			C1.GL_DATE,
			C1.PAYMENT_PRIORITY
			);
		EXCEPTION
			WHEN OTHERS THEN
				DBMS_OUTPUT.Put_Line(SQLERRM);
				lv_Err_Count	:=	lv_Err_Count + 1;
		END;
		lv_Scc_Count	:=	lv_Scc_Count	+	1;
	END LOOP;

	IF	lv_Err_Count	>	0	THEN
		ROLLBACK;
	END IF;

	INSERT INTO CAPCNV_LOG(
		PROG_ID,
		PROCESS_DATE,
		RECORD_PROCESSED,
		RECORD_REJECTED,
		RECORD_EXTRACTED,
		ERR_MSG
	) VALUES (
		lv_Prog_ID,
		SYSDATE,
		lv_Scc_Count,
		lv_Err_Count,
		lv_Scc_Count-lv_Err_Count,
		lv_Err_Msg
	);

	COMMIT;
END;
/
